﻿
-- Author      : Scott
-- Create Date : 10/27/2012 12:38:39 PM

-- Globals
   -- so we know when our configuration is loaded
 BGHelper_variablesLoaded = false;
   -- for configuration saving
 myBGHelperRealm = GetCVar("realmName")
 myBGHelperChar = UnitName("player")
 
BGHelper_points={}

BGHelper_points={ Orgrimmar = {}, AB = {}, WSG = {}, TP = {}, Gilneas = {}, EOTS = {}}

BGHelper_points.Orgrimmar = {numpoints = 1, point1 ={.45, .45, .55, .55}}

BGHelper_points.AB = {numpoints = 5, farm ={.520, .567, .592, .615},
									 bs ={.418, .362, .540, .525},
									 lm ={.329, .447, .436, .649}, 
									 mines ={.513, .200, .641, .368},
									 stables ={.332, .250, .419, .312}}

BGHelper_points.Gilneas = {numpoints = 3, mine ={.543, .329, .672, .454},
										  ww ={.552, .638, .687, .778},
										  lh ={.299, .563, .409, .675}}
										  
BGHelper_points.EOTS = {numpoints = 5, felreaver ={.386, .548, .451, .610},
									 bloodelf ={.515, .545, .580, .607},
									 magetower ={.370, .391, .451, .456}, 
									 draenai ={.513, .370, .607, .462},
									 flag ={.463, .454, .512, .522}}
BGHelper_points.TP= {numpoints = 2, hb ={.439, .747, .544, .902},
										  ab ={.537, .078, .650, .343}}
BGHelper_points.WSG= {numpoints = 2, hb ={.380, .765, .657, .913},
										  ab ={.375, .051, .639, .254}}


   
-----------------------------------------------------------------------------------------------------------------------------------------------
--Locals

-- default config settings
 local myBGHelperConfig_defaultOn = true;		-- addon enabled?
 local myBGHelperConfig_defaultMovable = true; 	-- movable?
 local myBGHelperConfig_defaultDebug = false --debug info
 local FlagBoxSize=.05
 
 local numplayersinraid = 0
 local activeplayersids = {}
 local enemies = {}
 local positions = {}
 local players = {name={}, positions={}  }
 local info = 0
 local instanceid = 0
 local instancetype = ""
 local defaultfstext = "------------"
 local printstring = "\n"
 local zoneastring = "\n"
 local zonebstring = "\n"
 local zonecstring = "\n"
 local zonedstring = "\n"
 local zoneestring = "\n"
 local unknownstring = "\n"
 local playercount = {0,0,0,0,0,0 }
 local loc = 0
 
 local FrameCollection = {};
 local flagX
 local flagY
 local flagToken
 local hordeflag={}
 local allianceflag ={}
 local hordeflagtaken=false
 local allianceflagtaken=false
 local counted=false
 
 

 -----------------------------------------------------------------------------------------------------------------------------------------------
 
 -- OnLoad
 function BGHelperFrame_OnLoad()
	-- register events
	 BGHelperFrame:RegisterEvent("ADDON_LOADED") -- eventually will call OnEvent
	-- BGHelperFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
	 BGHelperFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	 BGHelper:ScheduleRepeatingTimer(BGHelperTimer, 1) -- update timer function
	 BGHelper:Print("BGHelper Loaded - /bghelper or /bgh for options")
 end
 
 -- OnEvent
 function BGHelperFrame_OnEvent(frame, event, ...)
	 local arg1=...
	 if event == "ADDON_LOADED" and arg1 == "BGHelper" then
		-- execute event code in this function
--		BGHelper:Print("Variables Loaded Event")
		BGHelperFrame_VARIABLES_LOADED()
		ZoneSetup()
	 end
	 if event == "GROUP_ROSTER_UPDATE" then
--	     BGHelper:Print("Roster Change")
	 end
	 if event == "ZONE_CHANGED_NEW_AREA" then
		SetMapToCurrentZone()
		ZoneSetup()
--		BGHelper:Print("New Zone")
	end
 end
 
 -----------------------------------------------------------------------------------------------------------------------------------------
 
--Response to the Ace Timer, triggers every second
function BGHelperTimer()
	_,instancetype,_,_,_,_,_,instanceid = GetInstanceInfo() 
	if ((instancetype== "pvp") or (GetCurrentMapAreaID()==321)) and BGHelperConfig[myBGHelperRealm][myBGHelperChar].debug then
		BGHelper_FrameUpdate()
	end
	if(GetCurrentMapAreaID()==321) then
		OrgFrameUpdate()
	elseif(instanceid == 529) then
		ABFrameUpdate()
	elseif(instanceid==761) then
		GilneasFrameUpdate()
	elseif(instanceid==566) then
		EOTSFrameUpdate()
	elseif(instanceid==489) then
		WSGFrameUpdate()
	elseif(instanceid==726) then
		TPFrameUpdate()
	end
 end

 function ZoneSetup()
	SetMapToCurrentZone()
	_,_,_,_,_,_,_,instanceid = GetInstanceInfo() 
--	 BGHelper:Print("Trying to show the new frame")
--	 BGHelper:Print(instanceid)
	 --list of BGFrames to show
	OrgrimmarFrame:Hide()
	ArathiFrame:Hide()
	GilneasFrame:Hide()
	EOTSFrame:Hide()
	WSGFrame:Hide()
	TPFrame:Hide()
	if(GetCurrentMapAreaID()==321 and BGHelperConfig[myBGHelperRealm][myBGHelperChar].debug) then
		BGHelper:Print("closer")
		OrgrimmarFrame:Show()
	elseif(instanceid == 529) then
		ArathiFrame:Show()
	elseif(instanceid==761) then
		GilneasFrame:Show()
	elseif(instanceid==566) then
		EOTSFrame:Show()
	elseif(instanceid==489) then
		WSGFrame:Show()
	elseif(instanceid==726) then
		TPFrame:Show()
	else
--		BGHelper:Print("Hiding it")
		BGHelperTitle:SetText("BGHelper")
		OrgrimmarFrame:Hide()
		ArathiFrame:Hide()
		GilneasFrame:Hide()
		EOTSFrame:Hide()
		WSGFrame:Hide()
		TPFrame:Hide()
	end
 end
 ----------------------------------------------------------------------------------
 function ABFrameUpdate()
	SetPlayerText()
	zoneastring = defaultfstext.."\n"
	zonebstring = defaultfstext.."\n"
	zonecstring = defaultfstext.."\n"
	zonedstring = defaultfstext.."\n"
	zoneestring = defaultfstext.."\n"
	unknownstring = defaultfstext.."\n"
	for i=1,40,1 do
	if players["name"][i] then
		if CheckInBoundry(players["positions"][i], BGHelper_points.AB.farm) then
			zoneastring=zoneastring..players["name"][i].."\n"
			playercount[1]=playercount[1]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.AB.bs) then
			zonebstring=zonebstring..players["name"][i].."\n"
			playercount[2]=playercount[2]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.AB.lm) then
			zonecstring=zonecstring..players["name"][i].."\n"
			playercount[3]=playercount[3]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.AB.mines) then
			zonedstring=zonedstring..players["name"][i].."\n"
			playercount[4]=playercount[4]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.AB.stables) then
			zoneestring=zoneestring..players["name"][i].."\n"
			playercount[5]=playercount[5]+1
		else
			unknownstring = unknownstring..players["name"][i].."\n"	
			playercount[6]=playercount[6]+1
		end
	end
	end
	ABFarmPlayers:SetText(zoneastring)
	ABBlacksmithPlayers:SetText(zonebstring)
	ABLumberMillPlayers:SetText(zonecstring)
	ABMinesPlayers:SetText(zonedstring)
	ABStablesPlayers:SetText(zoneestring)
	ABUnknownPlayers:SetText(unknownstring)
	ABFarmNumbers:SetText(playercount[1])
	ABBlacksmithNumbers:SetText(playercount[2])
	ABLumberMillNumbers:SetText(playercount[3])
	ABMinesNumbers:SetText(playercount[4])
	ABStablesNumbers:SetText(playercount[5])
	ABUnknownNumbers:SetText(playercount[6])
	playercount = {0,0,0,0,0,0 }
	end

 
 -----------------------------------------------------------------------------------------
 function OrgFrameUpdate()
	SetPlayerText()
	zoneastring = defaultfstext.."\n"
	unknownstring = defaultfstext.."\n"
	for i=1,40,1 do
	if players["name"][i] then
		if CheckInBoundry(players["positions"][i], BGHelper_points.Orgrimmar.point1) then
			zoneastring=zoneastring..players["name"][i].."\n"
		 -- put more zones here
		else
			unknownstring = unknownstring..players["name"][i].."\n"	
		end
	end
	end
	ZoneAPlayers:SetText(zoneastring)
	OrgUnknownPlayers:SetText(unknownstring)
	end
-----------------------------------------------------------------------------------------------

 function GilneasFrameUpdate()
	SetPlayerText()
	zoneastring = defaultfstext.."\n"
	zonebstring = defaultfstext.."\n"
	zonecstring = defaultfstext.."\n"
	unknownstring = defaultfstext.."\n"
	for i=1,40,1 do
	if players["name"][i] then
		if CheckInBoundry(players["positions"][i], BGHelper_points.Gilneas.mine) then
			zoneastring=zoneastring..players["name"][i].."\n"
			playercount[1]=playercount[1]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.Gilneas.ww) then
			zonebstring=zonebstring..players["name"][i].."\n"
			playercount[2]=playercount[2]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.Gilneas.lh) then
			zonecstring=zonecstring..players["name"][i].."\n"
			playercount[3]=playercount[3]+1
		else
			unknownstring = unknownstring..players["name"][i].."\n"	
			playercount[6]=playercount[6]+1
		end
	end
	end
	GilneasMinePlayers:SetText(zoneastring)
	GilneasWaterworksPlayers:SetText(zonebstring)
	GilneasLighthousePlayers:SetText(zonecstring)
	GilneasUnknownPlayers:SetText(unknownstring)
	GilneasMineNumbers:SetText(playercount[1])
	GilneasWaterworksNumbers:SetText(playercount[2])
	GilneasLighthouseNumbers:SetText(playercount[3])
	GilneasUnknownNumbers:SetText(playercount[6])
	playercount = {0,0,0,0,0,0 }
	end

 
 -----------------------------------------------------------------------------------------
 ----------------------------------------------------------------------------------
 function EOTSFrameUpdate()
	SetPlayerText()
	zoneastring = defaultfstext.."\n"
	zonebstring = defaultfstext.."\n"
	zonecstring = defaultfstext.."\n"
	zonedstring = defaultfstext.."\n"
	zoneestring = defaultfstext.."\n"
	unknownstring = defaultfstext.."\n"
	for i=1,40,1 do
	if players["name"][i] then
		if CheckInBoundry(players["positions"][i], BGHelper_points.EOTS.felreaver) then
			zoneastring=zoneastring..players["name"][i].."\n"
			playercount[1]=playercount[1]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.EOTS.bloodelf) then
			zonebstring=zonebstring..players["name"][i].."\n"
			playercount[2]=playercount[2]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.EOTS.magetower) then
			zonecstring=zonecstring..players["name"][i].."\n"
			playercount[3]=playercount[3]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.EOTS.draenai) then
			zonedstring=zonedstring..players["name"][i].."\n"
			playercount[4]=playercount[4]+1
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.EOTS.flag) then
			zoneestring=zoneestring..players["name"][i].."\n"
			playercount[5]=playercount[5]+1
		else
			unknownstring = unknownstring..players["name"][i].."\n"	
			playercount[6]=playercount[6]+1
		end
	end
	end
	EOTSFelReaverPlayers:SetText(zoneastring)
	EOTSBloodElfPlayers:SetText(zonebstring)
	EOTSMageTowerPlayers:SetText(zonecstring)
	EOTSDraenaiPlayers:SetText(zonedstring)
	EOTSFlagPlayers:SetText(zoneestring)
	EOTSUnknownPlayers:SetText(unknownstring)
	EOTSFelReaverNumbers:SetText(playercount[1])
	EOTSBloodElfNumbers:SetText(playercount[2])
	EOTSMageTowerNumbers:SetText(playercount[3])
	EOTSDraenaiNumbers:SetText(playercount[4])
	EOTSFlagNumbers:SetText(playercount[5])
	EOTSUnknownNumbers:SetText(playercount[6])
	playercount = {0,0,0,0,0,0 }
	end

 
 -----------------------------------------------------------------------------------------
 
 function WSGFrameUpdate()
	SetPlayerText()
	GetFlagPositions()
	counted=false
	zoneastring = defaultfstext.."\n"
	zonebstring = defaultfstext.."\n"
	zonecstring = defaultfstext.."\n"
	zonedstring = defaultfstext.."\n"
	zoneestring = defaultfstext.."\n"
	unknownstring = defaultfstext.."\n"
	if(hordeflagtaken) then
		WSGHordeFlag:SetText("Horde Flag(taken)")
	else
		WSGHordeFlag:SetText("Horde Flag")
	end
	if(allianceflagtaken) then
		WSGAllianceFlag:SetText("Alliance Flag(taken)")
	else
		WSGHordeFlag:SetText("Alliance Flag")
	end
	for i=1,40,1 do
	if players["name"][i] then
		counted=false
		if CheckInBoundry(players["positions"][i], BGHelper_points.WSG.hb) then
			zoneastring=zoneastring..players["name"][i].."\n"
			playercount[1]=playercount[1]+1
			counted=true
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.WSG.ab) then
			zonebstring=zonebstring..players["name"][i].."\n"
			playercount[2]=playercount[2]+1
			counted=true
		end
		if CheckInBoundry(players["positions"][i], hordeflag) then
			zonecstring=zonecstring..players["name"][i].."\n"
			playercount[3]=playercount[3]+1
			counted=true
		elseif CheckInBoundry(players["positions"][i], allianceflag) then
			zonedstring=zonedstring..players["name"][i].."\n"
			playercount[4]=playercount[4]+1
			counted=true
		end
		if(counted==false) then
			unknownstring = unknownstring..players["name"][i].."\n"	
			playercount[6]=playercount[6]+1
		end
	
	end
	end
	WSGHordeBasePlayers:SetText(zoneastring)
	WSGAllianceBasePlayers:SetText(zonebstring)
	WSGHordeFlagPlayers:SetText(zonecstring)
	WSGAllianceFlagPlayers:SetText(zonedstring)
	WSGUnknownPlayers:SetText(unknownstring)
	WSGHordeBaseNumbers:SetText(playercount[1])
	WSGAllianceBaseNumbers:SetText(playercount[2])
	WSGHordeFlagNumbers:SetText(playercount[3])
	WSGAllianceFlagNumbers:SetText(playercount[4])
	WSGUnknownNumbers:SetText(playercount[6])
	if not(hordeflag[1]) then
		WSGHordeFlagPlayers:SetText("POSITION DATA \n NOT AVAILABLE")
	elseif hordeflag[1] and zonecstring=="" then
		WSGHordeFlagPlayers:SetText("FLAG FOUND \n SEE MAP \n FOR POSITION")
	end
	if allianceflagtaken and not(allianceflag[1]) then
		WSGHordeFlagPlayers:SetText("POSITION DATA NOT AVAILABLE")
	elseif allianceflag[1] and zonecstring=="" then
		WSGHordeFlagPlayers:SetText("FLAG FOUND \n SEE MAP \n FOR POSITION")
	end
	playercount = {0,0,0,0,0,0 }
 end
 
 
 -----------------------------------------------------------------------------------------
 
  -----------------------------------------------------------------------------------------
 
 
  function TPFrameUpdate()
	SetPlayerText()
	GetFlagPositions()
	counted=false
	zoneastring = defaultfstext.."\n"
	zonebstring = defaultfstext.."\n"
	zonecstring = defaultfstext.."\n"
	zonedstring = defaultfstext.."\n"
	zoneestring = defaultfstext.."\n"
	unknownstring = defaultfstext.."\n"
	if(hordeflagtaken) then
		TPHordeFlag:SetText("Horde Flag(taken)")
	else
		TPHordeFlag:SetText("Horde Flag")
	end
	if(allianceflagtaken) then
		TPAllianceFlag:SetText("Alliance Flag(taken)")
	else
		TPHordeFlag:SetText("Alliance Flag")
	end
	for i=1,40,1 do
	if players["name"][i] then
		counted=false
		if CheckInBoundry(players["positions"][i], BGHelper_points.TP.hb) then
			zoneastring=zoneastring..players["name"][i].."\n"
			playercount[1]=playercount[1]+1
			counted=true
		elseif CheckInBoundry(players["positions"][i], BGHelper_points.TP.ab) then
			zonebstring=zonebstring..players["name"][i].."\n"
			playercount[2]=playercount[2]+1
			counted=true
		end
		if CheckInBoundry(players["positions"][i], hordeflag) then
			zonecstring=zonecstring..players["name"][i].."\n"
			playercount[3]=playercount[3]+1
			counted=true
		elseif CheckInBoundry(players["positions"][i], allianceflag) then
			zonedstring=zonedstring..players["name"][i].."\n"
			playercount[4]=playercount[4]+1
			counted=true
		end
		if(counted==false) then
			unknownstring = unknownstring..players["name"][i].."\n"	
			playercount[6]=playercount[6]+1
		end
	
	end
	end
	TPHordeBasePlayers:SetText(zoneastring)
	TPAllianceBasePlayers:SetText(zonebstring)
	TPHordeFlagPlayers:SetText(zonecstring)
	TPAllianceFlagPlayers:SetText(zonedstring)
	TPUnknownPlayers:SetText(unknownstring)
	TPHordeBaseNumbers:SetText(playercount[1])
	TPAllianceBaseNumbers:SetText(playercount[2])
	TPHordeFlagNumbers:SetText(playercount[3])
	TPAllianceFlagNumbers:SetText(playercount[4])
	TPUnknownNumbers:SetText(playercount[6])
	if not(hordeflag[1]) then
		TPHordeFlagPlayers:SetText("POSITION DATA \n NOT AVAILABLE")
	elseif hordeflag[1] and zonecstring=="" then
		TPHordeFlagPlayers:SetText("FLAG FOUND \n SEE MAP \n FOR POSITION")
	end
	if allianceflagtaken and not(allianceflag[1]) then
		TPHordeFlagPlayers:SetText("POSITION DATA NOT AVAILABLE")
	elseif allianceflag[1] and zonecstring=="" then
		TPHordeFlagPlayers:SetText("FLAG FOUND \n SEE MAP \n FOR POSITION")
	end
	playercount = {0,0,0,0,0,0 }
 end
 
 
 -----------------------------------------------------------------------------------------
 
 
function GetFlagPositions()
	hordeflag={}
	allianceflag={}
	hordeflagtaken=false
	allianceflagtaken=false
	for i=1, GetNumBattlefieldFlagPositions() do
		flagX, flagY, flagToken = GetBattlefieldFlagPosition(i)
		if flagToken=="AllianceFlag" then
			allianceflag={flagX-FlagBoxSize, flagY-FlagBoxSize, flagX+FlagBoxSize, flagY+FlagBoxSize}
			allianceflagtaken=true
		end
		if flagToken=="HordeFlag" then
			hordeflag={flagX-FlagBoxSize, flagY-FlagBoxSize, flagX+FlagBoxSize, flagY+FlagBoxSize}
			hordeflagtaken=true
		end
	end
end

 
function SetPlayerText()
	getplayernames()
	getplayerpositions()
	InCombatRedBlueText()
end

function InCombatRedBlueText()
	for i=1,40,1 do
		if(UnitAffectingCombat("raid"..i)) then
			players["name"][i] = "|cFFFF0000"..players["name"][i].."|r"
		elseif(UnitIsDeadOrGhost("raid"..i)) then
			players["name"][i] = "|cFF2BE9FF"..players["name"][i].." *DEAD*".."|r"
		end
	end
end



--takes in a 2 coordinate player position, and a four coordinate boundry rectangle
--returns true or false
function CheckInBoundry( playerposition, boundrect)
if(boundrect[1]) then
		if(playerposition[1]>boundrect[1] and playerposition[1]<boundrect[3]) and (playerposition[2]>boundrect[2] and playerposition[2]<boundrect[4]) then
			return true
		else
			return false
		end
		else
			return false
		end
end


 -- Gets all player names in current raid
function getplayernames()
	for i=1,40,1 do
			info = GetRaidRosterInfo(i)
			players["name"][i]= info
			--BGHelper:Print(players["name"][i])
	end
	RemoveServerNames()
end 
 
 -- Gets all friendly player positions in current raid
function getplayerpositions()
	SetMapToCurrentZone()
	for i=1,40,1 do
			players["positions"][i] = {GetPlayerMapPosition("raid"..i)}
	end
end 

--Meant to update the debug positions
function BGHelper_FrameUpdate()
	getplayernames()
	getplayerpositions()
	printstring="\n"
	if players["name"][1] then --prevents the debug frame from printing if not in a raid
		for i=1,40,1 do
			if players["name"][i] then
				printstring = printstring..""..players["name"][i].." "..players["positions"][i][1].." "..players["positions"][i][2].."\n"		
			end
		end  
	BGHelperFramePlayersString:SetText(printstring)
	end
end

function RemoveServerNames()
	for i=1,40,1 do
		if players["name"][i] then
			loc= string.find(players["name"][i], "-")
			if not(loc==0) then
				players["name"][i] = string.sub(players["name"][i],1, loc-1)
				loc=0
			end
		end
	end
end

--The Test button
 function FrameUpdate_OnClick()
	BGHelper:Print("Test")
	 BGHelper_FrameUpdate()
	end
 
 --The targetpos button
 function TargetPos_OnClick()
	CurrentPos("target")
 end
 
 function CurrentPos(who)
   SetMapToCurrentZone()
	local posX, posY = GetPlayerMapPosition(who);
    BGHelper:Print(who .. " is currently at location " .. posX .. "," .. posY)
end
 
 
 
function BGHelperFrame_VARIABLES_LOADED()
	-- initialize our SavedVariable
	if ( not BGHelperConfig ) then 
	 	BGHelperConfig = {}; 
	end
	if ( not BGHelperConfig[myBGHelperRealm] ) then 
	 	BGHelperConfig[myBGHelperRealm] = {}; 
	end
	if ( not BGHelperConfig[myBGHelperRealm][myBGHelperChar] ) then 
	 	BGHelperConfig[myBGHelperRealm][myBGHelperChar] = {}; 
		BGHelper_ConfigToDefault()
	end

	-- record that we have been loaded
	BGHelper_variablesLoaded = true;
--	 BGHelper:Print("Variables Loaded now True")
	-- we know other addons have been "loaded" now

	-- configuration might have changed
	BGHelper_ConfigChange();
 end
 
 function BGHelper_ConfigChange()
	-- make sure that our profile has been loaded before allowing this function to be called
--	 BGHelper:Print(BGHelperConfig[myBGHelperRealm][myBGHelperChar].on)
--	 BGHelper:Print(BGHelperConfig[myBGHelperRealm][myBGHelperChar].movable)
	if ( not BGHelper_variablesLoaded ) then -- config not loaded
		BGHelperFrame:Hide(); -- turn our mod off
		return;
	end
	-- make sure to use the frame's name here, cannot rely on 'this' to mean the main frame
	if ( BGHelperConfig[myBGHelperRealm][myBGHelperChar].on ) then
		BGHelperFrame:Show(); -- show our mod frame
	else
		BGHelperFrame:Hide(); -- hide our mod frame
	end
	if ( BGHelperConfig[myBGHelperRealm][myBGHelperChar].movable ) then
		FrameMovable:Show()
		FrameCollection = {GetChildrenTree(BGHelperFrame)};
		BGHelperFrame:EnableMouse(true);
			for _,childframe in pairs (FrameCollection) do
				childframe:EnableMouse(true);
			end	
		BGHelperFrame:RegisterForDrag("LeftButton")
	else
		BGHelperFrame:RegisterForDrag()
		FrameCollection = {GetChildrenTree(BGHelperFrame)};
		BGHelperFrame:EnableMouse(false);
			for _,childframe in pairs (FrameCollection) do
				childframe:EnableMouse(false);
			end
		FrameMovable:Hide()
	end
	if ( BGHelperConfig[myBGHelperRealm][myBGHelperChar].debug ) then
		BGHelperFramePlayersString:Show()
		TestFrameUpdate:Show()
		TargetPos:Show()
		BattlefieldFlagInfo:Show()
	else
		BGHelperFramePlayersString:Hide()
		TestFrameUpdate:Hide()
		TargetPos:Hide()
		BattlefieldFlagInfo:Hide()
	end
	 if(BGHelperConfig[myBGHelperRealm][myBGHelperChar].scale) then
		BGHelperFrame:SetScale(BGHelperConfig[myBGHelperRealm][myBGHelperChar].scale)
	else
		BGHelperConfig[myBGHelperRealm][myBGHelperChar].scale=1
		ScaleSlider:SetValue(1)
	end
	  if(BGHelperConfig[myBGHelperRealm][myBGHelperChar].alpha) then
		BGHelperFrame:SetBackdropColor(0,0,0,BGHelperConfig[myBGHelperRealm][myBGHelperChar].alpha)
	else
		BGHelperConfig[myBGHelperRealm][myBGHelperChar].alpha=.5
		AlphaSlider:SetValue(.5)
	end
	ZoneSetup()
 end
 
 function BGHelper_ConfigToDefault()
	-- make sure that our profile has been loaded before allowing this function to be called
	if ( not BGHelper_variablesLoaded  ) then -- config not loaded
		BGHelperFrame:Hide(); -- turn our mod off
		return;
	end
	-- set our profile to defaults
	BGHelperConfig[myBGHelperRealm][myBGHelperChar].on = myBGHelperConfig_defaultOn;
	BGHelperConfig[myBGHelperRealm][myBGHelperChar].movable = myBGHelperConfig_defaultMovable;
	BGHelperConfig[myBGHelperRealm][myBGHelperChar].debug = myBGHelperConfig_defaultDebug;
	BGHelperConfig[myBGHelperRealm][myBGHelperChar].scale=1
	BGHelperConfig[myBGHelperRealm][myBGHelperChar].alpha=.5
	-- frame name used since called from various places
	-- set the location of the frame... in case they dragged it away
	BGHelperFrame:SetPoint("TOPLEFT", "MinimapCluster", "TOPLEFT", 122, -28);
	  -- wow automatically saves the location of frames on the screen!
	-- make sure the defaults are loaded onto our mod frame
	BGHelper_ConfigChange();
 end



function GetChildrenTree(Frame) --- Walk the frame hierarchy recursively adding children.
		if Frame:GetChildren() then
			for _,child in pairs({Frame:GetChildren()}) do
				if child:IsMouseEnabled() then
					tinsert(FrameCollection,child);
				end
				GetChildrenTree(child);
			end 
		end
	end
	

	function BattlefieldFlagInfo_OnClick()
			flagX, flagY, flagToken =  GetBattlefieldFlagPosition(1)
			BGHelper:Print(flagX, flagY, flagToken)
			flagX, flagY, flagToken =  GetBattlefieldFlagPosition(2)
			BGHelper:Print(flagX, flagY, flagToken)

	end
	